'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _Handler2 = require('./Handler');

var _Handler3 = _interopRequireDefault(_Handler2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Default Handler to handle requests not in browser
 * @type {HTTPHandler}
 */
var HTTPHandler = function (_Handler) {
  (0, _inherits3.default)(HTTPHandler, _Handler);

  function HTTPHandler() {
    (0, _classCallCheck3.default)(this, HTTPHandler);
    return (0, _possibleConstructorReturn3.default)(this, (HTTPHandler.__proto__ || (0, _getPrototypeOf2.default)(HTTPHandler)).apply(this, arguments));
  }

  (0, _createClass3.default)(HTTPHandler, [{
    key: 'perform',


    /**
     * Perform request. Invoke callback with response.
     * @param  {Request} request User specified request
     */
    value: function perform(request) {
      this.client({
        url: request.url,
        method: request.method
      }, function (error, response, body) {
        request.callback(error, response, body);
      });
    }
    /**
     * Getter for HTTP client implementation.
     * @return {function} HTTP client
     */

  }, {
    key: 'client',
    get: function get() {
      if (typeof this._client === 'undefined') {
        this._client = require('request');
      }
      return this._client;
    }
    /**
     * Setter for HTTP client.
     * @param  {function} client HTTP client
     */
    ,
    set: function set(client) {
      this._client = client;
    }
  }]);
  return HTTPHandler;
}(_Handler3.default);

exports.default = HTTPHandler;