"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Handler to handle requests
 * @type {Handler}
 */
var Handler = function () {
  /**
   * Create Handler
   * @param  {Handler} successor Successor to delegate request if desired
   */
  function Handler(successor) {
    (0, _classCallCheck3.default)(this, Handler);

    this.successor = successor;
  }
  /**
   * Getter for successor
   * @return {Handler} Successor to delegate request if desired
   */


  (0, _createClass3.default)(Handler, [{
    key: "perform",
    value: function perform(request) {}
    /**
     * Delegate request to successor if desired
     * @param  {Request} request User specified request
     */

  }, {
    key: "delegate",
    value: function delegate(request) {
      if (this.successor instanceof Handler) {
        this.successor.perform(request);
      }
    }
  }, {
    key: "successor",
    get: function get() {
      return this._successor;
    }
    /**
     * Setter for successor
     * @param  {Handler} successor Successor to delegate request if desired
     */
    ,
    set: function set(successor) {
      this._successor = successor;
    }
  }]);
  return Handler;
}();

exports.default = Handler;