"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * User specified request to YouTube API
 * @type {Request}
 */
var Request = function () {
  /**
   * Create request
   * @param  {Object}   parameters Headers and query request parameters
   * @param  {Function(error, response, body)} callback   User specified callback for response
   * @param  {Object}   specs      YouTube Search API Specification
   * @return {Request}              Request
   */
  function Request() {
    var parameters = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var callback = arguments[1];
    var specs = arguments[2];
    (0, _classCallCheck3.default)(this, Request);

    this.parameters = parameters;
    this.callback = callback;
    this.specs = specs;
  }
  /**
   * Getter for callback
   * @return {Function(error, response, body)} User specified callback for response
   */


  (0, _createClass3.default)(Request, [{
    key: "callback",
    get: function get() {
      return this._callback;
    }
    /**
     * Setter for callback
     * @param  {Function(error, response, body)} callback User specified callback for response
     */
    ,
    set: function set(callback) {
      this._callback = callback;
    }
  }]);
  return Request;
}();

exports.default = Request;