'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _HTTPHandler = require('./HTTPHandler');

var _HTTPHandler2 = _interopRequireDefault(_HTTPHandler);

var _Handler2 = require('./Handler');

var _Handler3 = _interopRequireDefault(_Handler2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Handler to make XHR requests in browser.
 * @type {XHRHandler}
 */
var XHRHandler = function (_Handler) {
  (0, _inherits3.default)(XHRHandler, _Handler);

  function XHRHandler() {
    (0, _classCallCheck3.default)(this, XHRHandler);
    return (0, _possibleConstructorReturn3.default)(this, (XHRHandler.__proto__ || (0, _getPrototypeOf2.default)(XHRHandler)).apply(this, arguments));
  }

  (0, _createClass3.default)(XHRHandler, [{
    key: 'perform',


    /**
     * Perform request. Invoke callback with response. When client not available, delegate request.
     * @param  {Request} request User specified request
     */
    value: function perform(request) {
      if (this.client.open) {
        this.client({
          url: request.url,
          method: request.method
        }, function (error, response, body) {
          request.callback(error, response, body);
        });
      } else {
        this.delegate(request);
      }
    }
    /**
     * Getter for XHR client. Provide default if undefined.
     * @return {function} XHR client
     */

  }, {
    key: 'client',
    get: function get() {
      if (typeof this._client === 'undefined') {
        this._client = require('xhr');
      }
      return this._client;
    }
    /**
     * Setter for XHR client.
     * @param  {function} client XHR client
     */
    ,
    set: function set(client) {
      this._client = client;
    }
    /**
     * Getter for successor Handler. Provides default successor if undefined.
     * @return {Handler} Successor to delegate request if desired
     */

  }, {
    key: 'successor',
    get: function get() {
      if (typeof this._successor === 'undefined') {
        this._successor = new _HTTPHandler2.default();
      }
      return this._successor;
    }
    /**
     * Setter for successor Handler.
     * @param  {Handler} successor Successor to delegate request if desired
     */
    ,
    set: function set(successor) {
      this._successor = successor;
    }
  }]);
  return XHRHandler;
}(_Handler3.default);

exports.default = XHRHandler;