'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _DefaultClient = require('./DefaultClient');

var _DefaultClient2 = _interopRequireDefault(_DefaultClient);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * YouTube search interface
 * @type {YouTube}
 */
var YouTube = function () {

  /**
   * Create YouTube interface
   * @param  {client} client Client to invoke requests
   */
  function YouTube(client) {
    (0, _classCallCheck3.default)(this, YouTube);

    this.client = client;
  }
  /**
   * Getter for client. Provide default client if undefined.
   * @return {Client} Client to invoke requests
   */


  (0, _createClass3.default)(YouTube, [{
    key: 'search',

    /**
     * Search YouTube
     * @param  {Request} request User specified request
     */
    value: function search(request) {
      this.client.invoke(request);
    }
  }, {
    key: 'client',
    get: function get() {
      if (typeof this._client === 'undefined') {
        this._client = new _DefaultClient2.default();
      }
      return this._client;
    }
    /**
     * Setter for client.
     * @param  {Client} client Client to invoke requests
     */
    ,
    set: function set(client) {
      this._client = client;
    }
  }]);
  return YouTube;
}();

exports.default = YouTube;